<?php
/*********************************************************
* DO NOT REMOVE *

Project: PHP Photo Gallery 1.0
Url: http://www.phpgalleryscript.org/

License------------------------------------------------:
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
End License----------------------------------------------

*********************************************************/

session_start();
if($_SESSION['admin']!='')
{

  @set_time_limit(300);
  require_once('../jadro/base.php');
  require_once('../jadro/core.func.inc.php');
  require_once('../jadro/addfunc.php');
  require_once('../jadro/functions.php');
  require_once('../jadro/categories.inc.php');
  require_once('../jadro/libs/thumbnailer/thumbnail.inc.php');
  require_once('../jadro/libs/exif/exif.inc.php');
  require_once('../jadro/photo.inc.php');
  require_once('../jadro/libs/phpwatermark/watermark.php');
  require_once('../jadro/libs/xajax/xajax.inc.php');

  global $xajax;
  $xajax = new xajax();
  $xajax->registerFunction('ajax_add_photo');
  $xajax->registerFunction('ajax_recreate_categ_cache');
  $xajax->registerFunction('ajax_get_photo_files');

  definevars("where id='REWRITE_ENABLED' or id='EXIF' or id='THUMBNAIL_WIDTH' or id='THUMBNAIL_HEIGHT' or id='THUMBNAIL_CONSTRAIN' or id='MIDWIDTH' or id='MIDHEIGHT' or id='MEDIUM_CONSTRAIN' or id='ADMIN_NAME' or id='WATERMARK'");

  function traverse_dir($d,$no)
  {
    $d=rtrim(rtrim($d,'\\'),'/') . '/';
    $ar=array();

    if(file_exists($d))
    {
      $dir=@opendir($d);

      while (false !== ($file = @readdir($dir)))
      {
        if($file!='.' && $file!='..')
        {
          if(is_file($d . $file))
          {
            if(!in_array($file,$no))
            {
              if(preg_match('/(\.jpg|\.gif|\.png)/i',$file))
              $ar[]=$file;
            }

          }

        }
      }

      @closedir($dir);
    }
    asort($ar);

    return $ar;
  }

  function traverse_dir_all($d,$no)
  {
    $d=rtrim(rtrim($d,'\\'),'/') . '/';

    $dir=@opendir($d);

    $ar=array();

    while (false !== ($file = @readdir($dir)))
    {
      if($file!='.' && $file!='..')
      {
        if(is_dir($d . $file))
        {
          $t=getar($d.$file,'/',0);
          if(!in_array($file,$no))
          {
            $o=array();
            $ar[]=str_replace(DATAPATH . '/import' ,'', $d).$file;
            $o=traverse_dir_all($d.$file,$no);

            if(is_array($o) && !empty($o))
            $ar=array_merge($ar,$o);

            unset($o);
          }

        }

      }
    }

    @closedir($dir);

    asort($ar);

    return $ar;
  }

  function ajax_recreate_categ_cache()
  {
    $resp=New xajaxResponse();
    writecatstocache();
    $resp->addAssign('final','innerHTML','<b>All photos added, no more photos found!</b><br />');
    return $resp;
  }

  function ajax_get_photo_files($d)
  {
    $resp=New xajaxResponse();
    $a=traverse_dir(DATAPATH . '/import/' . ltrim(str_replace('../','',$d),'/'),array('index.html','Thumbs.db','thumbs.db'));

    $resp->addScriptCall('rphoto_prepare',$a);
    return $resp;
  }

  function getar($s,$d,$n)
  {
    $ar=explode($d,$s);
    if($n=='last')
    return $ar[count($ar)-1];
    else
    return $ar[$n];
  }

  function check_categ($categ)
  {
    global $table,$db;

    $ar=array('+','=','|',')','(','*',',','.','>','<','?',':','"','\'','&','^','%','$','#','@','!','{','}','[',']','`','~','\\');
    $categ=trim($categ,'/');
    $categ=str_replace($ar,'',$categ);
    $categ=str_replace(' ','-',$categ);
    $r=getone($table['categories'],'id',"where catpath='" . str_replace('%2F','/',rawurlencode($categ)) . "'");

    if($r===false)
    {
      if(strpos($categ,'/')!==false)
      {
        $ncateg=explode('/',$categ);

        $n='';
        unset($ncateg[count($ncateg)-1]);

        if(count($ncateg)>0)
        {
          foreach($ncateg as $value)
          {
            $n.='/'.$value;
          }
          $ncateg=$n;
        }
        else
        $ncateg=$ncateg[0];

        unset($value,$n);

        $ncateg=trim($ncateg,'/');
        	
        check_categ($ncateg);

        $parentid=getone($table['categories'],'id',"where catpath='".str_replace('%2F','/',rawurlencode($ncateg)) . "'");
      }
      else
      $parentid=0;

      $r=addcategory(array('catname'=>getar($categ,'/','last')),$parentid);

      if($r)
      $db->Execute("UPDATE {$table['categories']} set catpath='".str_replace('%2F','/',rawurlencode($categ)) . "' where id='$r'");

    }

    return $r;
  }

  function ajax_add_photo($file,$categ)
  {

    global $db,$table;
    $resp=New xajaxResponse();

    $categ=trim(htmlspecialchars_m(str_replace('../','',$categ)),'/');

    $opt=array();
    $opt['featured']=0;
    $opt['caption']=$file;
    $opt['file']=$file;
    $opt['featured']=0;

    $photopath=DATAPATH . '/import/' . $categ . '/'. $file;

    $ex = explode('.', $file);

    if ($ex[1] == 'jpeg') {
      rename($photopath, DATAPATH . '/import/' . $categ . '/'. $ex[0] . '.jpg');
      $photopath = DATAPATH . '/import/' . $categ . '/'. $ex[0] . '.jpg';
    }

    if(file_exists($photopath))
    {
      $opt['categoryid']=check_categ($categ);

      if($opt['categoryid']>0)
      {
        $c=addimagetodb(array('approved'=>'yes','featured'=>$opt['featured'],'caption'=> $opt['caption'] ,'timehour'=>gmdate('D, d M Y H:i:s', time()).' GMT' ,'photodesc'=> '' , 'categoryid'=> $opt['categoryid'] ,'date'=>date('m').'-'.date('d') . '-' .date('Y')));

        if(!$c)
        {
          $er_tag['add']='Can not add the photo details to database.';
        }
        else
        {
          $mimetype=getmimetype($photopath);
          $pic=$c .'.'. $mimetype;

          //exif data
          if(EXIF==1)
          {
            $exifdata=exif_read($photopath);
            if($exifdata!==false)
            exif_savetodb($exifdata,$c);

            unset($exifdata);
          }

          //watermark
          if(WATERMARK==1)
          watermarkphoto_s($photopath);

          createphotothumbs($photopath,$pic);

          $hash=md5_file(DATAPATH . '/photos/' . $pic);

          $opt['photo']=$c . '_' .$hash . '.' . $mimetype;
          $opt['id']=$c;

          $db->Execute("UPDATE {$table['items']} set photo='".$opt['photo'] . "' where id='{$c}'");

          incnumphotos($opt['categoryid']);

          $resp->addScriptCall('js_addphoto',$opt);
          	

        }
      }
    }


    $resp->addScriptCall('rphoto_nextphoto');

    return $resp;

  }

  $xajax->processRequests();

  $smarty->assign('dirs',traverse_dir_all(DATAPATH . '/import',array('Photos','Photo','photos','photo','data')));

  $smarty->compile_dir = DATAPATH.'/admincache';
  $smarty->template_dir='./tpl/';
  $smarty->assign('usr',$_SESSION['admin']);
  $smarty->assign('title','Image importer');
  $smarty->assign('xajax',$xajax);
  $smarty->assign('xajax_dir',SITE_ROOT . '/jadro/libs/xajax/');
  $smarty->display('rphoto.tpl');

}
else
header('Location: index.php');