<?php
/*********************************************************
* DO NOT REMOVE *

Project: PHP Photo Gallery 1.0
Url: http://www.phpgalleryscript.org/

License------------------------------------------------:
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
End License----------------------------------------------

*********************************************************/

session_start();
if($_SESSION['admin']!='')
{
  @set_time_limit(300);
  require_once('../jadro/base.php');
  require_once('../jadro/core.func.inc.php');
  require_once('../jadro/addfunc.php');
  require_once('../jadro/libs/exif/exif.inc.php');
  require_once('../jadro/libs/thumbnailer/thumbnail.inc.php');
  require_once('../jadro/photo.inc.php');
  require_once('../jadro/functions.php');
  require_once('../jadro/libs/phpwatermark/watermark.php');
  require_once('../jadro/categories.inc.php');

  $_SESSION['multipleupload']='1';
  $_SESSION['instantstart']='';

  definevars("where id='EXIF' or id='THUMBNAIL_WIDTH' or id='THUMBNAIL_HEIGHT' or id='THUMBNAIL_CONSTRAIN' or id='MIDWIDTH' or id='MIDHEIGHT' or id='MEDIUM_CONSTRAIN' or id='WATERMARK' or id='REWRITE_ENABLED'");

  $smarty->assign('cat',intval($_REQUEST['c']));

  $smarty->assign('conts_sel_cat',' id="c" class="ss"');

  $added=0;
  $er_free=1;
  $er_tag=array();

  $smarty->assign('title','Add photo');

  if(!empty($_POST))
  {
    $_POST=array_map('htmlspecialchars_m',$_POST);

    if($_POST['caption']=='')
    {
      $er_tag['caption']='Photo name is missing.';
      $er_free=0;
    }

    if($_POST['c']=='')
    {
      $er_tag['c']='Please choose album.';
      $er_free=0;
    }

    if($_SESSION['uploadfile']=='')
    {
      $er_tag['uploadfile']='Please upload your photo.';
      $er_free=0;
    }

    if($_POST['exif']=='on')
    $smarty->assign('exif',1);
    else
    $smarty->assign('exif',0);

    if($_POST['WATERMARK']=='on')
    $smarty->assign('WATERMARK',1);
    else
    $smarty->assign('WATERMARK',0);

    if($_POST['FAVORITE']=='on')
    $favorite=1;
    else
    $favorite=0;

    $smarty->assign('FAVORITE',$favorite);

    if($_POST['photo_year']!='')
    $smarty->assign('photo_year',intval($_POST['photo_year']));

    if($_POST['photo_day']!='')
    $smarty->assign('photo_day',intval($_POST['photo_day']));

    if($_POST['photo_month']!='')
    $smarty->assign('photo_month',intval($_POST['photo_month']));

    if($er_free)
    {
      $categoryid=intval($_POST['c']);

      $date_taken='';
      if($_POST['photo_year']!='' && $_POST['photo_month']!='')
      $date_taken=$_POST['photo_month'] . ($_POST['photo_day']!='' ? '.' . $_POST['photo_day'] : '') .'.'. $_POST['photo_year'] ;
      	
      $c=addimagetodb(array('date_taken'=>$date_taken, 'approved'=>'yes','featured'=>$favorite, 'caption'=> $_POST['caption'] ,'timehour'=>gmdate('D, d M Y H:i:s', time()).' GMT' ,'photodesc'=> $_POST['photodesc'] , 'categoryid'=> $categoryid ,'date'=>date('m').'-'.date('d') . '-' .date('Y')));

      $added=1;

      if(!$c)
      {
        $er_free=0;
        $added=0;
        $er_tag['add']='Can not add the photo details to database.';
      }
      else
      {
        $smarty->assign('id',$c);
        $smarty->assign('photoname',$_POST['caption']);
        $smarty->assign('catid',$categoryid);

        $mimetype=getmimetype($_SESSION['uploadfile']);
        $pic=$c .'.'. $mimetype;
        $photopath=DATAPATH . '/upload/' . $_SESSION['uploadfile'];

        $ex = explode('.', $_SESSION['uploadfile']);
        if ($ex[1] == 'jpeg') {
          rename($photopath, DATAPATH . '/upload/' . $ex[0] . '.jpg');
          $photopath = DATAPATH . '/upload/' . $ex[0] . '.jpg';
        }
        
        //echo $photopath;
        //exit();
        //exif data
        if($_POST['exif']=='on')
        {
          $exifdata=exif_read($photopath);
          if($exifdata!==false)
          exif_savetodb($exifdata,$c);

          unset($exifdata);
        }

        //watermark
        if($_POST['WATERMARK']=='on')
        watermarkphoto_s($photopath);

        createphotothumbs($photopath,$pic);

        $hash=md5_file(DATAPATH . '/photos/' . $pic);

        $db->Execute("UPDATE {$table['items']} set photo='".$c . '_' .$hash . '.' . $mimetype . "' where id='{$c}'");

        $smarty->assign('categ',getone($table['categories'],'catpath',"where id='$categoryid'"));

        incnumphotos($categoryid);

        $_SESSION['uploadfile']='';
      }
      	
    }
  }
  else
  {
    $_SESSION['uploadfile']='';
    $smarty->assign('exif',EXIF);
    $smarty->assign('WATERMARK',WATERMARK);
  }

  if(!$er_free)
  $smarty->assign('errors',$er_tag);

  $smarty->assign('added',$added);
  $smarty->compile_dir = DATAPATH.'/admincache';
  $smarty->template_dir='./tpl/';
  $smarty->display('addphoto.tpl');
}
else
{
  session_destroy();
  header('Location: index.php');
}