<?php
/*********************************************************
* DO NOT REMOVE *

Project: PHP Photo Gallery 1.0
Url: http://www.phpgalleryscript.org/

License------------------------------------------------:
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
End License----------------------------------------------

*********************************************************/

//show 304 not modified - every photo url is unique
if(isset($_SERVER['HTTP_IF_MODIFIED_SINCE']))
{
	@header('Status: 304 Not Modified');
 	@header('HTTP/1.1 304 Not Modified');
 	die();
}

require_once('jadro/config.php');
require_once(DATAPATH . '/photovars.inc.php');

//ini_set('display_errors',1);
//error_reporting(E_ALL);

if(!function_exists('file_get_contents'))
{
	function file_get_contents($f)
	{
		$str='';

		$fp=@fopen($f,'rb');

		if($fp)
		{
			while(!feof($fp))
			$str.=@ fgets($fp,4096);

			@ fclose($fp);
		}

		return $str;
	}
}

//prevent hotlinking
if(@constant('PREVENT_HOTLINKING')==1)
{
	if($_SERVER['HTTP_REFERER']!='')
	{
		$urlref=@parse_url($_SERVER['HTTP_REFERER']);
		$urlref=strtolower($urlref['host']);
		$url=@parse_url(SITE_URL);
		$url=strtolower($url['host']);

		if($url!=$urlref)
		showerror();

		unset($url,$urlref);
	}
}

if(isset($_GET['photo']))
{
	$t=array();
	$t=explode('.',$_GET['photo']);
	$type=checkphototype($t[1]);

	unset($t);

	$id=array();
	$id=explode('_', $_GET['photo']);
	$id=intval($id[0]);

	if(isset($_GET['album']))
	{
		if(isset($type{0}))
		{
			if(isset($_GET['thumb']))
			processphoto($type,DATAPATH.'/photos/cat/thumb/' . $id . '.' . $type);
			else
			processphoto($type,DATAPATH.'/photos/cat/' . $id . '.' . $type);
		}
	}
	else
	{
		if(isset($type{0}))
		{
			if(isset($_GET['thumb']))
			processphoto($type,DATAPATH.'/photos/thumb/' . $id . '.' . $type);
			else
			{
				if(isset($_GET['medium']))
				processphoto($type,DATAPATH.'/photos/medium/' . $id . '.' . $type);
				else
				processphoto($type,DATAPATH.'/photos/' . $id . '.' . $type);
			}
		}
	}

}

showerror();

function checkphototype($type)
{
	$str='';
	$type=strtolower($type);

	switch($type)
	{
		case 'png':
			{
				$str='png';
				break;
			}

		case 'bmp':
			{
				$str='bmp';
				break;
			}
		case 'gif':
			{
				$str='gif';
				break;
			}
		case 'jpeg':
		case 'jpg':
			{
				$str='jpg';
				break;
			}

	}
	return $str;
}
function processphoto($type,$f)
{
	if(@file_exists($f))
	{
		@header('Last-Modified: '.gmdate('D, d M Y H:i:s', filemtime($f)).' GMT');
		@header('Content-Length: '. @filesize($f));
		if($type=='jpg')
		$type='jpeg';
		@header("Content-Type: image/$type");
		echo file_get_contents($f);
		die();
	}
	else
	showerror();
}
function showerror()
{
	@header('HTTP/1.1 404 Not Found');
	echo "Photo is removed or you don't have permission to access it.";
	die();
}